Bug 106479 - Implement context menu edit commands: cut, copy, paste for the Formula command input panel
Summary: Implement context menu edit commands: cut, copy, paste for the Formula comman...
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Formula Editor (show other bugs)
Version:
(earliest affected)
unspecified
Hardware: All All
: medium enhancement
Assignee: Maxim Monastirsky
QA Contact:
URL:
Whiteboard: target:5.4.0
Keywords:
Depends on:
Blocks: Formula-Editor Context-Menu
  Show dependency treegraph
 
Reported: 2017-03-10 15:24 UTC by Ramon Tavarez
Modified: 2017-05-08 03:14 UTC (History)
5 users (show)

See Also:
Crash report or crash signature:


Attachments
Image of the editing options a on right click menu (178.44 KB, image/png)
2017-03-10 15:24 UTC, Ramon Tavarez
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Ramon Tavarez 2017-03-10 15:24:54 UTC
Created attachment 131800 [details]
Image of the editing options a on right click menu

It would be great to have the editing options (cut, copy, paste) available at the menu displayed with the mouse's right click.

Acctually we need to go to the Edit Menu to use those options.

This enhancement can help us to save a lot of time when we are writing long mathematical formulas, specially on step by step descriptions or procedures.

The file attached shows my idea about the enhancement requested.
Comment 1 Buovjaga 2017-03-10 20:50:06 UTC
Not sure, what the rationale is for the current context menu. Yet, nothing is preventing you from saving a lot of time right now by using Ctrl-X, Ctrl-C and Ctrl-V for cut, copy and paste.
Comment 2 V Stuart Foote 2017-03-10 20:59:39 UTC
In normal Formula Editor mode (e.g. Tools -> Options -> Advanced: Enable Experimental features disabled) the system clipboard is linked to selections made in the Formula Command Window.  The main menu Edit -> Cut|Copy|Paste and Select All actions are each functional.

And because it functions from the menu, providing the Edit menu action for use in the Formula Command window as additional context menu entries should be possible.

But, as in the see-also bug 88744, when in the Visual Math Editor experimental feature is enabled (Tools -> Options -> Advanced: Enable Experimental features) the visual shell does not link to the system clipboard, and selection cut|copy|paste actions are disrupted.  So with the new Visual Math Editor the clipboard linkage needs attention, and providing context menu controls for Cut|Copy|Paste would be of use here as well.

Any work done for this should probably go ahead and bring the Visual Formula editor out of experimental mode.
Comment 3 Yousuf Philips (jay) 2017-04-18 13:49:50 UTC
(In reply to Ramon Tavarez from comment #0)
> Acctually we need to go to the Edit Menu to use those options.

You could use the buttons in the toolbar to get these functions. :D

(In reply to V Stuart Foote from comment #2)
> And because it functions from the menu, providing the Edit menu action for
> use in the Formula Command window as additional context menu entries should
> be possible.

Yep all thats needed is to modify the contextual menu and add the uno commands.
https://gerrit.libreoffice.org/#/c/36643/

> Any work done for this should probably go ahead and bring the Visual Formula
> editor out of experimental mode.

As selecting text in the visual formula editor doesnt enable the clipboard functions, not much can be fixed here for it.
Comment 4 Yousuf Philips (jay) 2017-05-03 21:25:14 UTC
Seems that my patch isnt sufficient to make it work and hopefully Maxim can do his magic. :D
Comment 5 Commit Notification 2017-05-07 22:33:46 UTC
Maxim Monastirsky committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=8da106529e85981ce37fbbd18160023c26cc7129

tdf#106479 Make edit context menu dispatcher based

It will be available in 5.4.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 6 Maxim Monastirsky 2017-05-07 22:36:49 UTC
As a side effect, this context menu now appears in the customization dialog.
Comment 7 V Stuart Foote 2017-05-08 03:14:05 UTC
On Windows 10 Pro 64-bit en-US with
Version: 5.4.0.0.alpha1+
Build ID: c3e0b7dd4e7b1d33b8555e0acdf9f44cfc043ca2
CPU threads: 8; OS: Windows 6.19; UI render: GL; 
TinderBox: Win-x86@39, Branch:master, Time: 2017-05-08_00:14:11
Locale: en-US (en_US); Calc: CL

Works great! Thanks Maxim and Jay...